////////////////////////////////////////////////////////////////////////////
//
//  uParse.h
//
//	Headerdatei des Parsers
//
//	Author 	: Rene Bllhoff
//  Created : around Okt. 2007
//
//	(c) 2005-2008 by Rene Bllhoff - reneboellhoff (at) gmx (dot) de - 
//
//////////////////////////////////////////////////////////////////////////////
//
//  This source file may be used and distributed without
//  restriction provided that this copyright statement is not
//  removed from the file and that any derivative work contains
//  the original copyright notice and the associated disclaimer.
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//										
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public
//  License along with this source; if not, download it	from
//  http://www.gnu.org/licenses/gpl.html	
//
////////////////////////////////////////////////////////////////////////////	

	#ifndef __UPARSE_H__
		#define __UPARSE_H__

			#define PARSE_CONFIG_FILE   "uparse_cfg.h"
			#define MAX_STRING_LEN			16
			#define MAX_DATA_ELEMENTS	 	 4


			#define PARSE_DATA_UNION
				#include PARSE_CONFIG_FILE
			#undef  PARSE_DATA_UNION

			#define PARSE_LIST_FUNC
				#include PARSE_CONFIG_FILE
			#undef  PARSE_LIST_FUNC

			typedef T_CMD_DATA_ELEMENT T_CMD_DATA_ELEMENTS [MAX_DATA_ELEMENTS];

			// datentyp fr aufruf von "befehl erkannt"
			typedef void (* T_PF_PARSE_CALL) (UCHAR ucCmd, T_CMD_DATA_ELEMENTS *pstData); 

			// datentyp fr value codec function
			typedef BOOL (* T_PF_VALUE_CODEC) (UCHAR **ppucText, T_CMD_DATA_ELEMENT *pstData); 

			// externals laden
			#define PARSE_COMMAND_FUNC
				#include PARSE_CONFIG_FILE
			#undef  PARSE_COMMAND_FUNC

			// enum fr codecs zusammenbauen
			enum {
				#define PARSE_CODEC(name,func,listname)   name, 
					#include PARSE_CONFIG_FILE
				#undef  PARSE_CODEC
			};

			// enum fr commands zusammenbauen
			enum {
				#define PARSE_COMMAND(name,string,func)	name,
					#ifdef PARSE_USE_HELP
				  	COMMAND_HELP,
					#endif
					#include PARSE_CONFIG_FILE
				#undef  PARSE_COMMAND
			};


			// fkt prototypen
			UCHAR 	ucParserProcess (UCHAR *pucText, BOOL *bFuncCalled);
			void 		vParserHelp 		(void);

		#endif
