////////////////////////////////////////////////////////////////////////////
//
//  uParse_Test.c
//
//	Demonstration des Parsers
//
//	Author 	: Rene Bllhoff
//  Created : around Okt. 2007
//
//	(c) 2005-2008 by Rene Bllhoff - reneboellhoff (at) gmx (dot) de - 
//
//////////////////////////////////////////////////////////////////////////////
//
//  This source file may be used and distributed without
//  restriction provided that this copyright statement is not
//  removed from the file and that any derivative work contains
//  the original copyright notice and the associated disclaimer.
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//										
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public
//  License along with this source; if not, download it	from
//  http://www.gnu.org/licenses/gpl.html	
//
////////////////////////////////////////////////////////////////////////////	

	#include "lib.h"



// dummy damit im eep was drin steht
UCHAR aucTest [] EEMEM = "hallo";



// sammelfunktion fr led on/led off-commands
void vSetLed (UCHAR ucCmd, T_CMD_DATA_ELEMENTS *pstElements)
{
	if (ucCmd == LED_ON)  { vUARTSendString ("LED ON\n\r"); }
	if (ucCmd == LED_OFF) { vUARTSendString ("LED OFF\n\r"); }
}

// funktion fr setdate-command
void vSetDate (UCHAR ucCmd, T_CMD_DATA_ELEMENTS *pstElements)
{
  vUARTSendString 	((char *) "New Date = "); 
	vUARTSendHexUCHAR	( (UCHAR) ((*pstElements) [0].ulLong)); 
  vUARTSendChar	 		('-'); 
	vUARTSendHexUCHAR ( (UCHAR) ((*pstElements) [1].ulLong)); 
  vUARTSendChar	 		('-'); 
	vUARTSendHexUCHAR	( (UCHAR) ((*pstElements) [2].ulLong)); 
  vUARTSendString 	((char *) "\n\r"); 
}

// funktion fr getdate-command
void vGetDate (UCHAR ucCmd, T_CMD_DATA_ELEMENTS *pstElements)
{
	vUARTSendString 	((char *) "do this and that and something else ...\n\r"); 
}



int main (void)
{
	UCHAR ucCmd;
	BOOL bCalled;

	vUARTInit ();

	sei ();

	vUARTSendString ("\x1b[2J\x1b[0;0H\n\rHallo test welt\n\r");

	while (1)
	{
	  if (bInputReceived)
		{
			bInputReceived = FALSE;
			switch (ucReceivedChar)
			{
				case 8  :
					vUARTSendString ("\x08 \x08");
					break;
				case 13 :
					vUARTSendString ("\n\r");
					break;
				default :
					vUARTSendChar (ucReceivedChar);
			}
		}

	  if (bProcessInput)
		{
			bProcessInput = FALSE;
			vUARTSendString ("\n\r");
			ucCmd = ucParserProcess (aucRData, &bCalled);
			memset (aucRData, 0, sizeof (aucRData));  // eingangs puffer lschen
			if (ucCmd != 0xff)
			{
				if (bCalled)
				{
					vUARTSendString 	("Ok\n\r");
				}
				else
				{
					vUARTSendString 	("Command ");
					vUARTSendHexUCHAR (ucCmd);
					vUARTSendString 	(" erkannt\n\rOk\n\r");
				}
			}
			else
			{
			  vUARTSendString 	("Syntax Error\n\r");
			}
		}

	}

  return 0;
}
