////////////////////////////////////////////////////////////////////////////
//
//  uParse_cfg.h
//
//	Konfiguration des Parsers
//
//	Author 	: Rene Bllhoff
//  Created : around Okt. 2007
//
//	(c) 2005-2008 by Rene Bllhoff - reneboellhoff (at) gmx (dot) de - 
//
//////////////////////////////////////////////////////////////////////////////
//
//  This source file may be used and distributed without
//  restriction provided that this copyright statement is not
//  removed from the file and that any derivative work contains
//  the original copyright notice and the associated disclaimer.
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//										
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public
//  License along with this source; if not, download it	from
//  http://www.gnu.org/licenses/gpl.html	
//
////////////////////////////////////////////////////////////////////////////	

	#ifdef PARSE_DATA_UNION

		typedef struct 
		{
			UCHAR ucType;
			union {
				ULONG ulLong;
				UCHAR  aucTextBuffer [10];
			};
		} T_CMD_DATA_ELEMENT;

	#endif



	#ifdef PARSE_COMMAND_FUNC

		extern void vTest     (UCHAR ucCmd, T_CMD_DATA_ELEMENTS *pstElements);
		extern void vSetLed 	(UCHAR ucCmd, T_CMD_DATA_ELEMENTS *pstElements);
		extern void vSetDate 	(UCHAR ucCmd, T_CMD_DATA_ELEMENTS *pstElements);
		extern void vGetDate  (UCHAR ucCmd, T_CMD_DATA_ELEMENTS *pstElements);

		#define PARSE_USE_HELP

	#endif


	#ifdef PARSE_LIST_FUNC
		#define vParserWriteChar(x)	vUARTSendChar (x)
	#endif

	#ifdef PARSE_CODEC
	//PARSE_CODEC(name,   			function,				descr (fr help)  )

		PARSE_CODEC(NUMBER_CODEC, bCheckNumber,		"[number]")
		PARSE_CODEC(NAME_CODEC,  	bCheckName	,		"[name]"	)
		PARSE_CODEC(STRING_CODEC, bCheckString,		"[string]")
  
	#endif


	#ifdef PARSE_COMMAND
	//PARSE_COMMAND	(name,   				string,    										function_to_call 	)

		PARSE_COMMAND	(TEST1,   			"test1 \x01, \x01" 					, NULL   						)
		PARSE_COMMAND	(TEST2,   			"test2 \x02" 								, NULL     					)
		PARSE_COMMAND	(TEST3,   			"test3 \x02, \x03" 					, NULL     					)

		PARSE_COMMAND	(LED_ON,   			"led on"        						, vSetLed 					)
		PARSE_COMMAND	(LED_OFF,    		"led off"										, vSetLed 					)
		PARSE_COMMAND	(SET_DATE,  		"set date \x01:\x01:\x01"		, vSetDate					)
		PARSE_COMMAND	(GET_DATE,  		"get date"                	, vGetDate					)

  
	#endif
