////////////////////////////////////////////////////////////////////////////
//
//  uart.h
//
//	Header fr einfache UART-Routinen zur Demonstration des Parsers
//
//	Author 	: Rene Bllhoff
//  Created : around Okt. 2007
//
//	(c) 2005-2008 by Rene Bllhoff - reneboellhoff (at) gmx (dot) de - 
//
//////////////////////////////////////////////////////////////////////////////
//
//  This source file may be used and distributed without
//  restriction provided that this copyright statement is not
//  removed from the file and that any derivative work contains
//  the original copyright notice and the associated disclaimer.
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//										
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public
//  License along with this source; if not, download it	from
//  http://www.gnu.org/licenses/gpl.html	
//
////////////////////////////////////////////////////////////////////////////	

	#ifndef __UART_H__
		#define __UART_H__


			//---------------------------------------------------------------
			//
			//	Funktionsprototypen
			//
			//---------------------------------------------------------------


			#define INPUT_LENGTH    80

			extern 	UCHAR aucRData [INPUT_LENGTH];
			extern 	UCHAR ucRPtr;
			extern 	BOOL  bProcessInput;
			extern  UCHAR ucInputLength;

			extern 	BOOL  bInputReceived;
			extern  UCHAR ucReceivedChar;



			#define UART_SEPARATION_CHAR 0x0d


			void 	vUARTInit					(void);
			void 	vUARTSendChar 		(UCHAR cData);
			void 	vUARTSendString 	(char *pcData);

			void 	vUARTSendHexUCHAR (UCHAR ucValue);
			void 	vUARTSendHexUINT 	(UINT uiValue);
			void 	vUARTSendHexULONG (ULONG ulValue);

			

		#endif



